## org.mozilla.javascript.ast
Class ObjectLiteral

    java.lang.Object
      org.mozilla.javascript.Node
          org.mozilla.javascript.ast.AstNode
              org.mozilla.javascript.ast.ObjectLiteral

All Implemented Interfaces:
  java.lang.Comparable<AstNode>, java.lang.Iterable<Node>, DestructuringForm

    public class ObjectLiteral

extends AstNode
implements DestructuringForm

AST node for an Object literal (also called an Object initialiser in Ecma-262). The elements list will always be non-`null`, although the list will have no elements if the Object literal is empty.

Node type is `Token.OBJECTLIT`.

    ObjectLiteral :
           {}
           { PropertyNameAndValueList }
     PropertyNameAndValueList :
           PropertyName : AssignmentExpression
           PropertyNameAndValueList , PropertyName : AssignmentExpression
     PropertyName :
           Identifier
           StringLiteral
           NumericLiteral

Nested Class Summary

Nested classes/interfaces inherited from class org.mozilla.javascript.ast.AstNode
`AstNode.DebugPrintVisitor, AstNode.PositionComparator`

Nested classes/interfaces inherited from class org.mozilla.javascript.Node
`Node.NodeIterator`

Field Summary

Fields inherited from class org.mozilla.javascript.ast.AstNode
`length, parent, position`

Fields inherited from class org.mozilla.javascript.Node

`ATTRIBUTE_FLAG, BOTH, CASEARRAY_PROP, CATCH_SCOPE_PROP, CONTROL_BLOCK_PROP, DECR_FLAG, DESCENDANTS_FLAG, DESTRUCTURING_ARRAY_LENGTH, DESTRUCTURING_NAMES, DESTRUCTURING_PARAMS, DESTRUCTURING_SHORTHAND, DIRECTCALL_PROP, END_DROPS_OFF, END_RETURNS, END_RETURNS_VALUE, END_UNREACHED, END_YIELDS, EXPRESSION_CLOSURE_PROP, first, FUNCTION_PROP, GENERATOR_END_PROP, INCRDECR_PROP, ISNUMBER_PROP, JSDOC_PROP, LABEL_ID_PROP, last, LAST_PROP, LEFT, lineno, LOCAL_BLOCK_PROP, LOCAL_PROP, MEMBER_TYPE_PROP, NAME_PROP, next, NON_SPECIALCALL, OBJECT_IDS_PROP, PARENTHESIZED_PROP, POST_FLAG, PROPERTY_FLAG, propListHead, REGEXP_PROP, RIGHT, SKIP_INDEXES_PROP, SPECIALCALL_EVAL, SPECIALCALL_PROP, SPECIALCALL_WITH, TARGETBLOCK_PROP, type, VARIABLE_PROP`

Constructor Summary
`ObjectLiteral()`
`ObjectLiteral(int pos)`
`ObjectLiteral(int pos, int len)`

Method Summary
`void` `addElement(ObjectProperty element)` Adds an element to the list, and sets its parent to this node.
`java.util.List<ObjectProperty>` `getElements()` Returns the element list.
`boolean` `isDestructuring()` Returns true if this node is in a destructuring position: a function parameter, the target of a variable initializer, the iterator of a for..in loop, etc.
`void` `setElements(java.util.List<ObjectProperty> elements)` Sets the element list, and updates the parent of each element.
`void` `setIsDestructuring(boolean destructuring)` Marks this node as being a destructuring form - that is, appearing in a context such as `for ([a, b] in ...)` where it's the target of a destructuring assignment.
`java.lang.String` `toSource(int depth)` Emits source code for this node.
`void` `visit(NodeVisitor v)` Visits this node, then visits each child property node, in lexical (source) order.

Methods inherited from class org.mozilla.javascript.ast.AstNode
`addChild, assertNotNull, codeBug, compareTo, debugPrint, depth, getAbsolutePosition, getAstRoot, getEnclosingFunction, getEnclosingScope, getLength, getLineno, getParent, getPosition, hasSideEffects, makeIndent, operatorToString, printList, setBounds, setLength, setParent, setPosition, setRelative, shortName, toSource`

Methods inherited from class org.mozilla.javascript.Node

`addChildAfter, addChildBefore, addChildrenToBack, addChildrenToFront, addChildToBack, addChildToFront, getChildBefore, getDouble, getExistingIntProp, getFirstChild, getIntProp, getJsDoc, getLastChild, getLastSibling, getNext, getProp, getScope, getString, getType, hasChildren, hasConsistentReturnUsage, iterator, labelId, labelId, newNumber, newString, newString, newTarget, putIntProp, putProp, removeChild, removeChildren, removeProp, replaceChild, replaceChildAfter, setDouble, setJsDoc, setLineno, setScope, setString, setType, toString, toStringTree`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ObjectLiteral

    public ObjectLiteral()

### ObjectLiteral

    public ObjectLiteral(int pos)

### ObjectLiteral

    public ObjectLiteral(int pos,
                         int len)

Method Detail

### getElements

    public java.util.List<ObjectProperty> getElements()

  Returns the element list. Returns an immutable empty list if there are no elements.

### setElements

    public void setElements(java.util.List<ObjectProperty> elements)

  Sets the element list, and updates the parent of each element. Replaces any existing elements.

  Parameters:
    `elements` - the element list. Can be `null`.

### addElement

    public void addElement(ObjectProperty element)

  Adds an element to the list, and sets its parent to this node.

  Parameters:
    `element` - the property node to append to the end of the list
  Throws:
    `IllegalArgumentException}` - if element is `null`

### setIsDestructuring

    public void setIsDestructuring(boolean destructuring)

  Marks this node as being a destructuring form - that is, appearing in a context such as `for ([a, b] in ...)` where it's the target of a destructuring assignment.

  Specified by:
    `setIsDestructuring` in interface `DestructuringForm`

### isDestructuring

    public boolean isDestructuring()

  Returns true if this node is in a destructuring position: a function parameter, the target of a variable initializer, the iterator of a for..in loop, etc.

  Specified by:
    `isDestructuring` in interface `DestructuringForm`

### toSource

    public java.lang.String toSource(int depth)

  Description copied from class: `AstNode`
  Emits source code for this node. Callee is responsible for calling this function recursively on children, incrementing indent as appropriate.

  Note: if the parser was in error-recovery mode, some AST nodes may have `null` children that are expected to be non-`null` when no errors are present. In this situation, the behavior of the `toSource` method is undefined: `toSource` implementations may assume that the AST node is error-free, since it is intended to be invoked only at runtime after a successful parse.

  Specified by:
    `toSource` in class `AstNode`
  Parameters:
    `depth` - the current recursion depth, typically beginning at 0 when called on the root node.

### visit

    public void visit(NodeVisitor v)

  Visits this node, then visits each child property node, in lexical (source) order.

  Specified by:
    `visit` in class `AstNode`
  Parameters:
    `v` - the object to call with this node and its children